#include <stdio.h>
#include <mpi.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <memory.h>

#define TAG 1

int main(int argc, char ** argv) {

//The only argument taken here is a positive integer N, so that we can compute the sum of all counting numbers less than or equal to N.

	int my_rank, world_size;
	int my_sum = 0;
	int total_sum = 0;

        char message[256], name[80];
        MPI_Status status;

	int j, k;
        int N = atoi(argv[1]);

	MPI_Init(&argc, &argv); /* note that argc and argv are passed by address */

        MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
        MPI_Comm_size(MPI_COMM_WORLD, &world_size);

	int *PartialSums = NULL;
	PartialSums = (int *)malloc(world_size*sizeof(int));

	int ChunkSize = N/world_size+1;

	int my_start = my_rank*ChunkSize + 1;
	int my_stop = (my_rank+1)*ChunkSize;
	
        printf("Node %d: ChunkSize = %d, my_start = %d, my_stop = %d\n", my_rank, ChunkSize, my_start, my_stop);	

	if (my_stop > N)
	{
		my_stop = N;
	}

	for(j=my_start; j<=my_stop; j++)
	{
		my_sum = my_sum+j;	
	}
	
	MPI_Gather(&my_sum, 1, MPI_INT, PartialSums, 1, MPI_INT, 0, MPI_COMM_WORLD);

	if (my_rank ==0)
	{
		printf("\n");
		for(k=0; k<world_size; k++)
		{
			printf("Node %d's numbers summed to %d \n", k, PartialSums[k]);
		}
		for(k=0; k<world_size; k++)
		{
			total_sum = total_sum+PartialSums[k];
		}
		printf("Node %d: The total sum is %d\n", my_rank, total_sum);
	}


    MPI_Finalize();

}
